#define MODBUSMASTER_GLOBAL

#include "sys.h"
#include "string.h"
#include "ModbusMaster.h"
#include "general.h"
#include "uart.h"
#include "timer.h"

/*********************************************************************************************************
** : TransCmd
** : MODBUSЭ鷢,ջӦ
** ڲ: ptxbuf:ָ;
**           prxbuf:ӦϢָ;
** ڲ: صݳ,<0ʾʧ
** ȫֱ: 
** ģ: 
** : 2006-4-8
********************************************************************************************************/
int16 TransCmd(uint8 bPort, uint8 *pTxBuf,uint16 *pRxBuf)
{
#define BUFSIZE	32
	static uint8 tempbuf[BUFSIZE];
	uint16 txlen,rxlen,timeout;
	uint16	temp,crc = 0;
	uint32	nLastSendTick,nTimeOutTick,nRcvState;

	int16	i,j,idx,nLen,bread,iStartIdx,iRecvCnt;

	if(0x10==pTxBuf[1])
	{
		txlen = 7 + pTxBuf[6] + 2 ;
		rxlen = 8;
	}
	else if(0x3==pTxBuf[1])
	{
		temp = ((uint16)pTxBuf[4] << 8) | pTxBuf[5]; 
		txlen = 8;
		rxlen = 3 + (temp<<1) + 2;
	}
	else if(0x6==pTxBuf[1])
	{
		txlen = 8;
		rxlen = 8;
	}
	else
		return -1;	//ݲ֧
	
	memcpy(tempbuf,pTxBuf,txlen);
	
	Uart_Send_Data(bPort,txlen,tempbuf);
	
	nLastSendTick = TICK_NOW;
	idx = 0;
	iRecvCnt = 0;
	iStartIdx = 0;
	timeout = 100;
	nRcvState = Rtu_Idle;

	for(; ;)
	{
		bread = UartRxQOutBlock(bPort, (u8_t*)&tempbuf[idx], sizeof(tempbuf));
		if(nRcvState == Rtu_Idle)
		{
			if (TimeElapsed(nLastSendTick, TICK_NOW) < 100)
//			if (TimeElapsed(nLastSendTick, TICK_NOW) < 10000)
			{
				if(bread > 0)
				{
					nLastSendTick = TICK_NOW;
					nTimeOutTick = TICK_NOW;
					idx += bread; 
					iRecvCnt += bread;
					nRcvState = Rtu_RcvData;
				}
			}
			else
			{
				return -1;
			}
		}
		else
		{
//			if (TimeElapsed(nLastSendTick, TICK_NOW) < T35_115200_MS)
			if (TimeElapsed(nLastSendTick, TICK_NOW) < 5)
			{
				if(bread > 0)
				{
					nLastSendTick = TICK_NOW;
					idx += bread; 
					iRecvCnt += bread;
				}
			}
			else
			{
				for(; ;)
				{
					if(tempbuf[iStartIdx] == 0x01)
					{
						if((iRecvCnt-iStartIdx-2) <= 0) 
							return -1;
						crc = crc_chk((uint8*)&tempbuf[iStartIdx],iRecvCnt-iStartIdx-2);
						temp = ((uint16)tempbuf[iRecvCnt-2]<<8)|tempbuf[iRecvCnt-1];
						if(crc == temp)
						{
							if(0x03==tempbuf[iStartIdx + 1])
							{
								for(i=0; i<(tempbuf[iStartIdx + 2]>>1); i++)
								{
									pRxBuf[i] = ((uint16)tempbuf[iStartIdx + 3 + (i<<1)]<<8) | tempbuf[(iStartIdx + 3 + (i<<1))+1];
								}
								iRecvCnt = tempbuf[iStartIdx + 2];
							}
							else
								iRecvCnt = 0;
							return iRecvCnt;
						}
						else
						{
							return -1;
						}
					}
					else
					{
						iStartIdx ++;
						if((iStartIdx >= iRecvCnt) || (iStartIdx >= BUFSIZE))
						{
							return -1;
						}
					}
				}
			}
		}
	}
}
/*********************************************************************************************************
** : ModbusMasterSend
** : RS485豸ļĴд(0x06 and 0x10)
** ڲ: iDevAddr:		RS485豸iDevAddr;
**			 iRegAddr:		豸ݵԪַ;
**           pData:			ָдָ;
**			 iLen:			дݳ;
** ڲ: Ӧֽ,<1
** ȫֱ: 
** ģ: TransCmd
** : 2016-4-8
********************************************************************************************************/
int16 ModbusMasterSend(uint8 bPort, uint8 iDevAddr,uint16 iRegAddr,uint16* pData,uint16 iLen)
{
	uint8	txbuf[256];
	uint16 	temp;
	uint16	ret = FALSE,i;
	int16		nCnt = -1;
	char szTimeout[8];
	
	if((iLen == 0) || (iLen >126))
		return -1;
	
	txbuf[0] = iDevAddr;
	if(iLen == 1)
	{
		txbuf[1] = 0x06;
		txbuf[2] = iRegAddr >> 8;
		txbuf[3] = iRegAddr&0xff;
		txbuf[4] = pData[0] >> 8;
		txbuf[5] = pData[0]&0xff;
		temp = crc_chk(txbuf,6);
		txbuf[6] = temp>>8;
		txbuf[7] = temp&0xff;
	}
	else
	{
		txbuf[1] = 0x10;
		txbuf[2] = iRegAddr >> 8;
		txbuf[3] = iRegAddr&0xff;
		txbuf[4] = iLen >> 8;
		txbuf[5] = iLen&0xff;
		txbuf[6] = iLen << 1;

		for(i=0; i<iLen; i++)
		{
			txbuf[7+(i<<1)] = pData[i]>>8;
			txbuf[7+(i<<1)+1] = pData[i]&0xff;
		}

		temp = crc_chk(txbuf,(iLen<<1) + 7);
		txbuf[(iLen<<1) + 7] = temp>>8;
		txbuf[(iLen<<1) + 8] = temp&0xff;
	}
	nCnt = TransCmd(bPort,txbuf,pData);
	
	if(nCnt < 0)
	{
		//LCD_PrintString(7, 108, (uint8*)"TxEr", 4, 0,0);
	}

	return nCnt;	
	
}

/*********************************************************************************************************
** : ModbusMasterRecv
** : ȡRS485豸Ĵ(0x03)
** ڲ: iDevAddr:	RS485豸iDevAddr;
**			 iRegAddr:	豸ݵԪַ;
**			 *bData:	ָյݵָ
**			 iLen:		ݳ;
** ڲ: ؽյֽ,<1
** ȫֱ: 
** ģ: TransCmd
** : 2016-4-8
********************************************************************************************************/
int16 ModbusMasterRecv(uint8 bPort, uint8 iDevAddr,uint16 iRegAddr,uint16* pData,uint16 iLen)
{
	uint8	txbuf[256];
	uint16 	temp;
	uint16 	ret = FALSE,i;
	char szTimeout[8];
	int16		nCnt = -1;

	txbuf[0] = iDevAddr;
	txbuf[1] = 0x03;
	txbuf[2] = iRegAddr >> 8;
	txbuf[3] = iRegAddr&0xff;
	txbuf[4] = iLen >> 8;
	txbuf[5] = iLen&0xff;
	temp = crc_chk(txbuf,6);
	txbuf[6] = temp>>8;
	txbuf[7] = temp&0xff;

	nCnt = TransCmd(bPort,txbuf,pData);

	return nCnt;
}

