#ifndef __MODBUSMASTER_H__
#define __MODBUSMASTER_H__

#ifndef MODBUSMASTER_GLOBAL
#define MODBUSMASTER_EXT extern
#else
#define MODBUSMASTER_EXT 
#endif

#define RETRYTIMES 			10
#define CNC_ID					1

#define BUFSIZE	32
typedef struct{
	uint8 bFrameBuf[BUFSIZE];
	uint32 nRcvIdx;
	uint32 nRcvLen;
	uint32 nRcvCnt;
	uint32 nStartIdx;
	uint32 nRcvState;
	uint32 nLastRtuRcvMsTick;

}ModbusRcvDef;

uint16 crc_chk(uint8* iData, uint16 iLen);
int16 ModbusMasterRecv(uint8 bPort,uint8 iDevAddr,uint16 iRegAddr,uint16* pData,uint16 iLen);
int16 ModbusMasterSend(uint8 bPort,uint8 iDevAddr,uint16 iRegAddr,uint16* pData,uint16 iLen);

#define T15_9600_US 	1719	//1.5T * 11/9600 * 1000000
#define T35_9600_US 	4011	//3.5T * 11/9600 * 1000000
#define T15_9600_MS 	(T15_9600_US/1000 + 1)	//1.5T * 11/9600 * 1000
#define T35_9600_MS 	(T35_9600_US/1000 + 1)		//3.5T * 11/9600 * 1000

#define T15_115200_US 	143	//1.5T * 11/115200 * 1000000
#define T35_115200_US 	334	//3.5T * 11/9600 * 1000000
#define T15_115200_MS 	(T15_115200_US/1000 + 1)	//1.5T * 11/9600 * 1000
#define T35_115200_MS 	(T35_115200_US/1000 + 1)		//3.5T * 11/9600 * 1000

/**********************************************************************/
#define Rtu_Idle			1
#define Rtu_RcvData		2
#define Rtu_DataProc	3
/**********************************************************************/
MODBUSMASTER_EXT ModbusRcvDef g_stModbusRcv;
//MODBUSMASTER_EXT uint32 nMasterModbusRcvState;
#endif