#include <stdio.h>
#include <string.h>
#include "sys.h"
#include "ParasProc.h"
#include "general.h"
#include "uart.h"
#include "main.h"

SysParasCfgDef g_SysCfgParas;

const SysParasCfgDef dftSysParas = 
{
	0,			//Ĭʷݸ
	0,			//ûA
	-1,			//CRC
};

void LoadDftParas(void)
{
    g_SysCfgParas = dftSysParas;
    LogPrint(0,"Default paras is loaded!");
    
		g_SysCfgParas.siCrc = crc_chk((u8*)&g_SysCfgParas,sizeof(SysParasCfgDef)-4);
    NorFlash_Write(NORFLASH_PARA_CFG_ADDR_BASE, VP_PARA_CFG_ADDR_BASE,(u8 *)&g_SysCfgParas, sizeof(SysParasCfgDef));

    LogPrint(0,"Default paras and CRC are saved!");

}

void LoadParasFrNorflash(void)
{
    SysParasCfgDef tmpParasCfg;
		u16 crc;
	u8 temp;
		char strMsg[64];
	
		
		NorFlash_Read(NORFLASH_PARA_CFG_ADDR_BASE, VP_PARA_CFG_ADDR_BASE,(u8 *)&tmpParasCfg, sizeof(SysParasCfgDef));
		crc = crc_chk((u8*)&tmpParasCfg,sizeof(SysParasCfgDef)-4);

		if(crc == tmpParasCfg.siCrc)
		{
				g_SysCfgParas = tmpParasCfg;
				LogPrint(0,"Paras load from NorFlash OK!");

		}
		else
		{
				LogPrint(0,"Paras Invalid,load default...");
				LoadDftParas();
		}

}

void SaveParasToNorflash(void)
{
		read_dgus_vp(VP_PARA_CFG_ADDR_BASE,(u8*)&g_SysCfgParas,sizeof(g_SysCfgParas)/2);
		g_SysCfgParas.siCrc = crc_chk((u8*)&g_SysCfgParas,sizeof(SysParasCfgDef)-4);
		LogPrint(0,"iCrc Cal.(%02X)",g_SysCfgParas.siCrc);
    NorFlash_Write(NORFLASH_PARA_CFG_ADDR_BASE, VP_PARA_CFG_ADDR_BASE,(u8 *)&g_SysCfgParas, sizeof(SysParasCfgDef));
	
    LogPrint(0,"SysParas and CRC are saved!");
}

void LoadParas(u8 bDefaut)
{
	u16 Temp_Data[2];
	u16 i;
//Channel 0
	Temp_Data[0] = 0x0;							//(0x300):ָ
	Temp_Data[1] = 0x800; 						//(0x301):
	write_dgus_vp(0x300,(u8*)&Temp_Data[0],2);	
		
	NorFlash_Read(Nor_Human_A_B,Dgus_Human_A_B,(u8*)&g_SysCfgParas.uiCurHumanAB,sizeof(g_SysCfgParas.uiCurHumanAB));

	LogPrint(0,"CurHuman(%d)",(u16)g_SysCfgParas.uiCurHumanAB);
	if(g_SysCfgParas.uiCurHumanAB > 1)
	{
		g_SysCfgParas.uiCurHumanAB = 0;
		NorFlash_Write(Nor_Human_A_B,Dgus_Human_A_B,(u8*)&g_SysCfgParas.uiCurHumanAB,sizeof(g_SysCfgParas.uiCurHumanAB));
	}

	for(i=0; i<HUMAN_NUM; i++)
	{
		NorFlash_Read(Nor_HistoryADataCnt+(i<<1),Dgus_Temp_vp,(u8*)&g_SysCfgParas.ulHistoryDataCnt[i],sizeof(g_SysCfgParas.ulHistoryDataCnt[i]));
		LogPrint(0,"HistoryCurve%d:Cnt(%ld)",i,g_SysCfgParas.ulHistoryDataCnt[i]);
	
	}
	//bDefaut = 1;
	if((g_SysCfgParas.ulHistoryDataCnt == 0xffffffff) || bDefaut)
	{
		for(i=0; i<HUMAN_NUM; i++)
		{
			g_SysCfgParas.ulHistoryDataCnt[i] = 0;
			NorFlash_Write(Nor_HistoryADataCnt + (i<<1),Dgus_Temp_vp,(u8*)&g_SysCfgParas.ulHistoryDataCnt[i],sizeof(g_SysCfgParas.ulHistoryDataCnt[i]));
		}
	}
//			g_SysCfgParas.ulHistoryDataCnt[0] = 0;
//			NorFlash_Write(Nor_HistoryADataCnt + 0,Dgus_Temp_vp,(u8*)&g_SysCfgParas.ulHistoryDataCnt[0],sizeof(g_SysCfgParas.ulHistoryDataCnt[0]));
}
