#ifndef SHMQUEUE_H
#define SHMQUEUE_H

#define FILTER_BUFSIZE  10

#ifndef min
#define min(a,b) ((a) < (b) ? (a) : (b))
#endif
typedef int32_t QDATA_TYPE;
typedef int8_t 	QLEN_TYPE;

typedef struct
{
  QLEN_TYPE   	nSize;        //Queue size
  QLEN_TYPE   	nHead;        //put in head, always point to a empty position
  QLEN_TYPE   	nTail;        //get from tail
  QDATA_TYPE*   pQueue;       //pointer to the queue buffer
}ShmQueue;

void ShmInit(ShmQueue* pQueue, QLEN_TYPE nQSize, QDATA_TYPE* pDataBuffer);
void ShmReset(ShmQueue* pQueue);
QLEN_TYPE ShmLength(ShmQueue* pQueue);
QLEN_TYPE ShmInBlock(ShmQueue* pQueue, QDATA_TYPE* pData, QLEN_TYPE nLen);
QLEN_TYPE ShmOutBlock(ShmQueue* pQueue, QDATA_TYPE* pData, QLEN_TYPE nLen);

#endif