#include <string.h>
#include <stdio.h>
#include <stdarg.h>

#include "sys.h"
#include "general.h"
#include "uart.h"
#include "timer.h"

#define MAX_LOG_SIZE	256
char g_sMsg[MAX_LOG_SIZE];

u32 TimeElapsed(u32 tLast, u32 tNow)	//ms
{
//	u32_t tNow = TIME;
	u32 tPeriod = ((tNow>=tLast) ? (tNow-tLast) : ((u32)0xFFFFFFFF-tLast+tNow));
	return tPeriod;
}

/////////////////////////////////////////////////////////////////////////////////////////
void swap_word(u16_t* buf)
{
	u16_t cTemp;

	cTemp = ((buf[0]&0xFF) << 8) + ((buf[0] >> 8) & 0xFF);
	buf[0] = cTemp;
}
void LogPrint(int level, char* format, ... )
{
	u32_t tick, len; 
	va_list ap;
	INTERRUPT_SAVE_AREA
	
	#if defined(ENLOG)
	
	if (level >= LOG_LEVEL)		return;

	tick = TICK_NOW; //GetTickCount(); avoid locking //2017-09-09 xjp~~
	INTERRUPT_DISABLE

	va_start(ap, format);
		memset(g_sMsg, 0, sizeof(g_sMsg));
		if ((format[0] == '%') && (format[1] == 'T'))
		{
//			snprintf(g_sMsg, 10, "%02d:%02d:%02d ", tick/(3600000), (tick%3600000)/60000, (tick%60000)/1000);
//			vsnprintf(g_sMsg + 9, sizeof(g_sMsg) - 12, format+2, ap);
			sprintf(g_sMsg, "%02d:%02d:%02d ", (u16_t)(tick/3600000), (u16_t)((tick%3600000)/60000), (u16_t)((tick%60000)/1000));
			vsprintf(g_sMsg + 9, format+2, ap);
		}
		else if((format[0] == '\r') && (format[1] == '\n'))
		{
//			vsnprintf(g_sMsg, sizeof(g_sMsg) - 1, format, ap);
			vsprintf(g_sMsg, format, ap);
		}
		else
		{
			u8 hour,minute,second;
//			snprintf(g_sMsg, 10, "%02d:%02d:%02d ", tick/(3600000), (tick%3600000)/60000, (tick%60000)/1000); //2017-09-09 xjp~~
//			vsnprintf(g_sMsg + 9, sizeof(g_sMsg) - 12, format, ap); //2017-09-09 xjp~~
			sprintf(g_sMsg, "%02d:%02d:%02d ", (u16_t)(tick/3600000), (u16_t)((tick%3600000)/60000), (u16_t)((tick%60000)/1000));
			vsprintf(g_sMsg + 9, format, ap); //2017-09-09 xjp~~
		}
		len = strlen(g_sMsg); //2017-09-09 xjp~~
		if ((g_sMsg[len-1] != '\r') && (g_sMsg[len-1] != '\n')) //2017-09-09 xjp~~
			strcat(g_sMsg, "\r\n"); //2017-09-09 xjp~~
	va_end(ap);

//		va_start(ap, format);
//		memset(g_sMsg, 0, sizeof(g_sMsg));
//		vsnprintf(g_sMsg, sizeof(g_sMsg) - 1, format, ap);
//	va_end(ap);
	
	INTERRUPT_ENABLE
	
	Uart_Send_Data(UART5,strlen(g_sMsg),(u8_t*)g_sMsg);	

#endif	//#if defined(ENLOG)
}

u16 crc_chk(u8* buf, u16 length)
{
	u16 j;
	u16 reg_crc=0xFFFF;
	while(length--)
	{
		reg_crc ^= *buf++;
		for(j=0;j<8;j++)
		{
			if(reg_crc & 0x01)
			{ /* LSB(b0)=1 */
				reg_crc=(reg_crc>>1) ^ 0xA001;
			}
			else
			{
				reg_crc=reg_crc >>1;
			}
		}
	}
	swap_word(&reg_crc);
	return reg_crc;
}
