#include <string.h>
#include <stdio.h>
#include <math.h>
#include "timer.h"
#include "ui.h"
#include "uart.h"
#include "dwin8283.h"
#include "RX8130.h"
#include "mpr.h"
#include "TpProc.h"
#include "general.h"
#include "main.h"
#include "ShmQueue.h"
#include "ParasProc.h"

//ShmQueue  g_qPressSampVal;
//u16  			g_nPressSampValBuff[PRESS_SAMPVAL_QSIZE+1]; 
#define FILTERA_QSIZE 20
#define FILTERB_QSIZE 10
ShmQueue   g_qFilterA,g_qFilterB;//,g_qHistoryPara,g_qHistoryDate,g_qHistoryTime;
QDATA_TYPE g_nFilterABuff[FILTERA_QSIZE+1]; 
QDATA_TYPE g_nFilterBBuff[FILTERB_QSIZE+1]; 

SysFlagDef 	g_bitFlag;
SysVarDef 	g_SysVar;
BpmCtxDef 	g_BpmCtx;

u16 Temp_Data[10];
u16	Sound_Lv,Light_Lv,Sound_Lv_Bak,Light_Lv_Bak;
u16 Measure_Flag=0;
u16 Rtc_Set[4];
/*******************************************************************************************/
#if 0
bit g_MeasureFlag=0,g_I2CError=0;
//u8 g_RunMode=0,*g_DataBuffer;
u16 g_TempIndex,g_Index=0,Each_20ms_Count=0,Next_Flag;

u16 Pressure_Now=0,Pressure_First=0,Pressure_Now_Display=0,Pressure_Last,Pressure_Last_Last,Measure_Flag=0,Pump_Flag=0,Valve_Flag=0,t_Diver[16];

u16 High_Pressure_Flag,Low_Pressure_Flag,MaiBo_Flag,Temp_Data[10],Report_Flag=0;

u16 Min_Value,Max_Value,Min_Index,Max_Index,Clear_Histroy_Flag,Max,Min,Err_Num;
	
u16 Tem_Data[1024],Human_A_B=0,Human_A_History_Count_Total,Human_B_History_Count_Total,Human_History_Count_Now,Page,Human_History_Count_Now_Bak=0xFFFF;	

#endif	 
/********************************************************************************************/

//sbit Pump	= P3^0;					// Pumpź
//sbit Valve	= P3^1;					// Valveź	
sbit 	portChargStatus = P1^4;

#define Start_Pump() 	RelayCtl(RELAY_PUMP,1)
#define Stop_Pump() 	RelayCtl(RELAY_PUMP,0)

#define Start_Valve() RelayCtl(RELAY_VALVE,0)
#define Stop_Valve() 	RelayCtl(RELAY_VALVE,1)

/*******************************************************************************************
     : Relay_Init
   : ʼ̵IOƿ
   : none
   : none
 ޸ʷ  :
        : 20211025
        : xujianping
 ޸   : 
********************************************************************************************/
void Relay_Init(void)
{
	SetPinOut(3,0);	//Config P1.5 as relay1 output port
	SetPinOut(3,1);	//Config P1.6 as relay1 output port

	//close all relay
	PinOutput(3,0,0);
	PinOutput(3,1,0);
}

/*******************************************************************************************
     : RelayCtl
   : ̵
   : bRelayIdx:̵(0~1)0ʾм̵
						 bCtl:ؿ,(0close1open)
   : none
 ޸ʷ  :
       : 20211118
       : xujianping
 ޸  : 
********************************************************************************************/	
void RelayCtl(u8 bRelayIdx,u8 bCtl)
{
	if(bRelayIdx == RELAY_PUMP)
	{
		PinOutput(3,0,bCtl!=0);
		g_bitFlag.bits.bPumpOnOff = (bCtl != 0);
		if(bCtl)
			LogPrint(0,"PUMP ON!");
		else
			LogPrint(0,"PUMP OFF!");
	}
	else if(bRelayIdx == RELAY_VALVE)
	{
		PinOutput(3,1,bCtl!=0);
		g_bitFlag.bits.bValveOnOff = (bCtl != 0);
		if(bCtl)
			LogPrint(0,"VALVE ON!");
		else
			LogPrint(0,"VALVE OFF!");
	}
	else
	{
		PinOutput(3,0,bCtl!=0);
		PinOutput(3,1,bCtl!=0);
		g_bitFlag.bits.bPumpOnOff = (bCtl != 0);
		g_bitFlag.bits.bValveOnOff = (bCtl != 0);
		if(bCtl)
		{
			LogPrint(0,"PUMP ON!");
			LogPrint(0,"VALVE ON!");
		}
		else
		{
			LogPrint(0,"PUMP OFF!");
			LogPrint(0,"VALVE OFF!");
		}
	}
}


/*******************************************************************************************
     : void PeriTest(uvoid)
   : ԺʱӦ #if 0
   : none
   : none
 ޸ʷ  :
        : 20211025
        : xujianping
 ޸   : 
********************************************************************************************/
void PeriTest(void)
{
	#if 0
	u32 nPeriTestTick;
	u16 temp;
	u16 temp2;
	u8 bTemp;
	bit toggle = 0;
	
	nPeriTestTick = TICK_NOW;
	while(1)
	{
		//test relay
		#if 0
		if((TimeElapsed(nPeriTestTick,TICK_NOW)) > 2000)
		{
			nPeriTestTick = TICK_NOW;
			
			RelayCtl(1,toggle);
			toggle = ~toggle;
			RelayCtl(2,toggle);
			toggle = ~toggle;
		}
		#endif
		
		#if 0
//		if((TimeElapsed(nPeriTestTick,TICK_NOW)) > 50)
		{
			//ȡ¶ֵ
			temp = get_press(DS_COOLING1,&temp2);
			write_dgus_vp(VP_CUR_COOLING_TEMP,(u8*)&temp,1);	//
			write_dgus_vp(VP_CUR_COOLING_TEMP_ADVAL,(u8*)&temp2,1);	//

			temp = get_temp(DS_FREEZING,&temp2);
			write_dgus_vp(VP_CUR_FREEZING_TEMP,(u8*)&temp,1);	//
			write_dgus_vp(VP_CUR_FREEZING_TEMP_ADVAL,(u8*)&temp2,1);	//

//			nPeriTestTick = TICK_NOW;
		}
		#endif

		#if 0
		
		if((TimeElapsed(nPeriTestTick,TICK_NOW)) > 10)
		{
			nPeriTestTick = TICK_NOW;
			GetPressTemp(&temp,NULL);
//			ReadByte(0x02,&bTemp);
		}

		#endif	
		
		#if 0
		if((TimeElapsed(nPeriTestTick,TICK_NOW)) > 2000)
		{
			nPeriTestTick = TICK_NOW;
			Rx8130_GetTime();
		}
		#endif
		
		#if 1
			LogPrint(0,"High_Pressure_Report!");
			High_Pressure_Report(120);
			LogPrint(0,"Low_Pressure_Report!");
			Low_Pressure_Report(80);
		#endif
		
	}
	#endif
}

/*******************************************************************************************
     : void DrawPoint(u16 uiData,u8 uiChannel)
   : ߻
   : uiData:
						 uiChannel:	ͨ
   : none
 ޸ʷ  :
        : 20211223
        : xujianping
 ޸   : 
********************************************************************************************/
void DrawPoint(u16 uiData,u8 uiChannel)
{
	u16 uiTempData[4];
	uiTempData[0] = 0x5AA5;
	uiTempData[1] = 0x0100; 
	uiTempData[2] = uiChannel<<8 | 0x01;
	uiTempData[3] = uiData*100;
	write_dgus_vp(0x310,(u8*)uiTempData,4);	
}
/*******************************************************************************************
     : void InitCurveChannel(u8 uiChannel)
   : ʼͨ
   : bChannel:	ͨ
				     bEnable:ʾ
   : none
 ޸ʷ  :
        : 20211223
        : xujianping
 ޸   : 
********************************************************************************************/
void InitCurveChannel(u8 bChannel,u8 bEnable)
{
	u16 TempData[2];
	TempData[0] = 0;								//
	if(bEnable)
		TempData[1] = HISTORY_CURVE_POINT_MAX_NUM; 		//
	else
		TempData[1] = 0;	//disable curve display
	write_dgus_vp(0x300 | bChannel<<1,(u8*)&TempData[0],2);	
}

/*******************************************************************************************
     : void DispHistoryData(void)
   : ʾʷ
   : none
   : none
 ޸ʷ  :
        : 20211223
        : xujianping
 ޸   : 
********************************************************************************************/
void DispHistoryData(void)
{
	u16 uiTemp;
	s32 slTemp;
	
	
	if(g_SysCfgParas.uiCurHumanAB)
	{
		NorFlash_Read(Nor_HistoryDateB_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Test_Vp,(u8*)&Temp_Data[0],4);
		NorFlash_Read(Nor_HistoryTimeB_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Test_Vp,(u8*)&Temp_Data[2],4);
	}
	else
	{
		NorFlash_Read(Nor_HistoryDateA_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Test_Vp,(u8*)&Temp_Data[0],4);
		NorFlash_Read(Nor_HistoryTimeA_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Test_Vp,(u8*)&Temp_Data[2],4);
	}
	LogPrint(0,"ReadNor(ptr%d):%d-%d-%d %d:%d:%d",g_SysVar.siHistoryDataPtr,Temp_Data[0]&0xff,Temp_Data[1]>>8,Temp_Data[1]&0xff,Temp_Data[2]&0xff,Temp_Data[3]>>8,Temp_Data[3]&0xff);
	uiTemp = 2000 + (Temp_Data[0]&0xff);
	write_dgus_vp(Dgus_HistoryYear,(u8*)&uiTemp,1);	//
	
	uiTemp = Temp_Data[1]>>8;
	write_dgus_vp(Dgus_HistoryMonth,(u8*)&uiTemp,1);	//

	uiTemp = (Temp_Data[1]&0xff)<<8 | Temp_Data[2];
	write_dgus_vp(Dgus_HistoryDH,(u8*)&uiTemp,1);	//,Сʱ
	
	uiTemp = Temp_Data[3];
	write_dgus_vp(Dgus_HistoryMS,(u8*)&uiTemp,1);	//,
	
	//display last history SBP,DBP and PULSE
	if(g_SysCfgParas.uiCurHumanAB)
	{
		NorFlash_Read(Nor_HistoryCurveB_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
	}
	else
	{
		NorFlash_Read(Nor_HistoryCurveA_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
	}
	LogPrint(0,"ReadNor(ptr%d):SBP(%d)-DBP(%d)-PUL(%d)",g_SysVar.siHistoryDataPtr,(u16)(slTemp>>16),(u16)((slTemp>>8)&0xff),(u16)(slTemp&0xff));

	uiTemp = slTemp>>16;
	write_dgus_vp(Dgus_HistorySPB,(u8*)&uiTemp,1);
	
	uiTemp = (slTemp>>8)&0xff;
	write_dgus_vp(Dgus_HistoryDPB,(u8*)&uiTemp,1);

	uiTemp = slTemp&0xff;
	write_dgus_vp(Dgus_HistoryPUL,(u8*)&uiTemp,1);
}

/*******************************************************************************************
     : void UiPagePoll(void)
   : ͼʾ
   : none
   : none
 ޸ʷ  :
        : 20211025
        : xujianping
 ޸   : 
********************************************************************************************/
void UiPagePoll(void)
{
	u16 uiPage,uiTemp;
	s16 i;
	s32 slTemp;
	u16 uiSBP,uiDBP,uiPUL;
	u16 uiHistoryCurveArrow[HISTORY_CURVE_POINT_DISP_NUM];
	u16 uiCnt;
	u16 uiNor_HistoryCurve_AddrBase;
	
	read_dgus_vp(Dgus_Page,(u8*)&uiPage,1);
	if(uiPage == 22)
	{
		if(g_SysCfgParas.uiCurHumanAB)
		{
			uiNor_HistoryCurve_AddrBase = Nor_HistoryCurveB_AddrBase;
		}
		else
		{
			uiNor_HistoryCurve_AddrBase = Nor_HistoryCurveA_AddrBase;
		}

		if(g_SysVar.uiLastPage != uiPage)
		{	
			LogPrint(0,"HistoryDataCnt%d(%ld)",g_SysCfgParas.uiCurHumanAB,g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]);
			if(g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB] == 0)
			{
				InitCurveChannel(1,0);
				InitCurveChannel(2,0);
				InitCurveChannel(3,0);
				//arrow all off
				memset((u8*)uiHistoryCurveArrow,0,sizeof(uiHistoryCurveArrow));
				for(i=0; i<HISTORY_CURVE_POINT_DISP_NUM; i++)
				{
					write_dgus_vp(Dgus_HistoryArrowBase+i,(u8*)&uiHistoryCurveArrow[i],1);
				}
				// ʱʾ0
				uiTemp = 0;
				write_dgus_vp(Dgus_HistoryYear,(u8*)&uiTemp,1);		//
				write_dgus_vp(Dgus_HistoryMonth,(u8*)&uiTemp,1);	//
				write_dgus_vp(Dgus_HistoryDH,(u8*)&uiTemp,1);			//,Сʱ
				write_dgus_vp(Dgus_HistoryMS,(u8*)&uiTemp,1);			//,
				//SBP,DBP,PULʾ0
				write_dgus_vp(Dgus_HistorySPB,(u8*)&uiTemp,1);
				write_dgus_vp(Dgus_HistoryDPB,(u8*)&uiTemp,1);
				write_dgus_vp(Dgus_HistoryPUL,(u8*)&uiTemp,1);
				return;
			}
			InitCurveChannel(1,1);
			InitCurveChannel(2,1);
			InitCurveChannel(3,1);

			g_SysVar.siHistoryDataPtr = g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM;
			g_SysVar.siHistoryDataPtr--;
			if(g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]<HISTORY_CURVE_POINT_DISP_NUM)
			{
				g_SysVar.siArrowPos = g_SysVar.siHistoryDataPtr;
				for(i=g_SysVar.siHistoryDataPtr; i>=0; i--)
				{
					NorFlash_Read(uiNor_HistoryCurve_AddrBase + i<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
					LogPrint(0,"ReadNor:SBP(%d)-DBP(%d)-PUL(%d)",(u16)(slTemp>>16),(u16)((slTemp>>8)&0xff),(u16)(slTemp&0xff));
					DrawPoint(slTemp>>16,1);
					DrawPoint((slTemp>>8)&0xff,2);
					DrawPoint(slTemp&0xff,3);
				}
			}
			else
			{
				g_SysVar.siArrowPos = HISTORY_CURVE_POINT_DISP_NUM - 1;
				uiCnt = 0;
				for(i=g_SysVar.siHistoryDataPtr; i>=0; i--)
				{
					NorFlash_Read(uiNor_HistoryCurve_AddrBase + i<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
					LogPrint(0,"ReadNor:SBP(%d)-DBP(%d)-PUL(%d)",(u16)(slTemp>>16),(u16)((slTemp>>8)&0xff),(u16)(slTemp&0xff));
					DrawPoint(slTemp>>16,1);
					DrawPoint((slTemp>>8)&0xff,2);
					DrawPoint(slTemp&0xff,3);
					uiCnt++;
					
					if(uiCnt >= HISTORY_CURVE_POINT_DISP_NUM)
						break;
				}
				if(uiCnt < HISTORY_CURVE_POINT_DISP_NUM)
				{
					for(i=HISTORY_CURVE_POINT_MAX_NUM-1; i<=0; i--)
					{
						NorFlash_Read(uiNor_HistoryCurve_AddrBase + i<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
						LogPrint(0,"ReadNor:SBP(%d)-DBP(%d)-PUL(%d)",(u16)(slTemp>>16),(u16)((slTemp>>8)&0xff),(u16)(slTemp&0xff));
						DrawPoint(slTemp>>16,1);
						DrawPoint((slTemp>>8)&0xff,2);
						DrawPoint(slTemp&0xff,3);
						uiCnt++;
						if(uiCnt>= HISTORY_CURVE_POINT_DISP_NUM) break;
					}
				}

			}
			memset((u8*)uiHistoryCurveArrow,0,sizeof(uiHistoryCurveArrow));
			uiHistoryCurveArrow[g_SysVar.siArrowPos] = 1;
			for(i=0; i<HISTORY_CURVE_POINT_DISP_NUM; i++)
			{
				write_dgus_vp(Dgus_HistoryArrowBase+i,(u8*)&uiHistoryCurveArrow[i],1);
			}
			DispHistoryData();
		}
		else
		{
			if((Measure_Flag == 3) || (Measure_Flag == 4))
			{
				if(g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB] == 0) return;
				
				if(g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]<HISTORY_CURVE_POINT_DISP_NUM)
				{
					if(Measure_Flag == 3)
					{
						g_SysVar.siHistoryDataPtr--;
						if(g_SysVar.siHistoryDataPtr < 0)
							g_SysVar.siHistoryDataPtr = 0;
					}
					else
					{
						g_SysVar.siHistoryDataPtr++;
						if(g_SysVar.siHistoryDataPtr >= g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB])
							g_SysVar.siHistoryDataPtr = g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB] - 1;
					}
					g_SysVar.siArrowPos = g_SysVar.siHistoryDataPtr;
					uiHistoryCurveArrow[g_SysVar.siArrowPos] = 1;
				}
				else if((g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]>HISTORY_CURVE_POINT_DISP_NUM) &&
							 (g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]<=HISTORY_CURVE_POINT_MAX_NUM))
				{
					if(Measure_Flag == 3)
					{
						g_SysVar.siHistoryDataPtr--;
						if(g_SysVar.siHistoryDataPtr < 0)
							g_SysVar.siHistoryDataPtr = 0;

						g_SysVar.siArrowPos --;
						if(g_SysVar.siArrowPos < 0)
						{
							g_SysVar.siArrowPos = 0;
							if(g_SysVar.siHistoryDataPtr >= (HISTORY_CURVE_POINT_DISP_NUM - 1))
							{
								uiCnt = 0;
								for(i=g_SysVar.siHistoryDataPtr; i<=0; i--)
								{
									NorFlash_Read(uiNor_HistoryCurve_AddrBase + i<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
									LogPrint(0,"ReadNor:SBP(%d)-DBP(%d)-PUL(%d)",(u16)(slTemp>>16),(u16)((slTemp>>8)&0xff),(u16)(slTemp&0xff));
									DrawPoint(slTemp>>16,1);
									DrawPoint((slTemp>>8)&0xff,2);
									DrawPoint(slTemp&0xff,3);
									uiCnt++;
									if(uiCnt>= HISTORY_CURVE_POINT_DISP_NUM) break;
								}
							}
						}
					}
					else
					{
						g_SysVar.siHistoryDataPtr++;
						if(g_SysVar.siHistoryDataPtr >= g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB])
							g_SysVar.siHistoryDataPtr = g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB] - 1;

						g_SysVar.siArrowPos ++;
						if(g_SysVar.siArrowPos>=HISTORY_CURVE_POINT_DISP_NUM)
						{
							g_SysVar.siArrowPos = HISTORY_CURVE_POINT_DISP_NUM - 1;
							if((g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB] - g_SysVar.siHistoryDataPtr) > HISTORY_CURVE_POINT_DISP_NUM)
							{
								uiCnt = 0;
								for(i=g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]-1; i<=0; i--)
								{
									NorFlash_Read(uiNor_HistoryCurve_AddrBase + i<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
									LogPrint(0,"ReadNor:SBP(%d)-DBP(%d)-PUL(%d)",(u16)(slTemp>>16),(u16)((slTemp>>8)&0xff),(u16)(slTemp&0xff));
									DrawPoint(slTemp>>16,1);
									DrawPoint((slTemp>>8)&0xff,2);
									DrawPoint(slTemp&0xff,3);
									uiCnt++;
									if(uiCnt>= HISTORY_CURVE_POINT_DISP_NUM) break;
								}
							}
						}
					}
				}
				else
				{
					u16 uiResLen;
					u16 uiReDrawFlag = 0;
					if(Measure_Flag == 3)
					{
						g_SysVar.siHistoryDataPtr--;
						if(g_SysVar.siHistoryDataPtr < 0)
							g_SysVar.siHistoryDataPtr = HISTORY_CURVE_POINT_MAX_NUM - 1;
						else if(g_SysVar.siHistoryDataPtr < (g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM))
							g_SysVar.siHistoryDataPtr = g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM;

						g_SysVar.siArrowPos --;
						if(g_SysVar.siArrowPos < 0)
						{
							g_SysVar.siArrowPos = 0;
							if(g_SysVar.siHistoryDataPtr > g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM)
								uiResLen = g_SysVar.siHistoryDataPtr - g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM + 1;
							else
								uiResLen = g_SysVar.siHistoryDataPtr + HISTORY_CURVE_POINT_MAX_NUM - g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM + 1;
							
							if(uiResLen > HISTORY_CURVE_POINT_DISP_NUM)
							{
								uiReDrawFlag = 1;
							}
						}
					}
					else
					{
						g_SysVar.siHistoryDataPtr++;
						if(g_SysVar.siHistoryDataPtr >= HISTORY_CURVE_POINT_MAX_NUM)
							g_SysVar.siHistoryDataPtr = 0;
						else if(g_SysVar.siHistoryDataPtr >= (g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM))
							g_SysVar.siHistoryDataPtr = g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM - 1;

						g_SysVar.siArrowPos ++;
						if(g_SysVar.siArrowPos>=HISTORY_CURVE_POINT_DISP_NUM)
						{
							u16 uiResLen;
							g_SysVar.siArrowPos = HISTORY_CURVE_POINT_DISP_NUM - 1;
							if(g_SysVar.siHistoryDataPtr > g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM)
								uiResLen = g_SysVar.siHistoryDataPtr - g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM + 1;
							else
								uiResLen = g_SysVar.siHistoryDataPtr + HISTORY_CURVE_POINT_MAX_NUM - g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM + 1;
							if(uiResLen > HISTORY_CURVE_POINT_DISP_NUM)
							{
								uiReDrawFlag = 1;
							}
						}
					}
					if(uiReDrawFlag)
					{
						uiCnt = 0;
						for(i=g_SysVar.siHistoryDataPtr; i<=0; i--)
						{
							NorFlash_Read(uiNor_HistoryCurve_AddrBase + i<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
							LogPrint(0,"ReadNor:SBP(%d)-DBP(%d)-PUL(%d)",(u16)(slTemp>>16),(u16)((slTemp>>8)&0xff),(u16)(slTemp&0xff));
							DrawPoint(slTemp>>16,1);
							DrawPoint((slTemp>>8)&0xff,2);
							DrawPoint(slTemp&0xff,3);
							uiCnt++;
							if(uiCnt>= HISTORY_CURVE_POINT_DISP_NUM) break;
						}
						if(uiCnt < HISTORY_CURVE_POINT_DISP_NUM)
						{
							for(i=HISTORY_CURVE_POINT_DISP_NUM-1; i<=0; i--)
							{
								NorFlash_Read(uiNor_HistoryCurve_AddrBase + i<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
								LogPrint(0,"ReadNor:SBP(%d)-DBP(%d)-PUL(%d)",(u16)(slTemp>>16),(u16)((slTemp>>8)&0xff),(u16)(slTemp&0xff));
								DrawPoint(slTemp>>16,1);
								DrawPoint((slTemp>>8)&0xff,2);
								DrawPoint(slTemp&0xff,3);
								uiCnt++;
								if(uiCnt>= HISTORY_CURVE_POINT_DISP_NUM) break;
								
							}
						}
					}
				}
				memset((u8*)uiHistoryCurveArrow,0,sizeof(uiHistoryCurveArrow));
				uiHistoryCurveArrow[g_SysVar.siArrowPos] = 1;
				for(i=0; i<HISTORY_CURVE_POINT_DISP_NUM; i++)
				{
					write_dgus_vp(Dgus_HistoryArrowBase+i,(u8*)&uiHistoryCurveArrow[i],1);
				}
				DispHistoryData();
				Measure_Flag = -1;
				write_dgus_vp(Dgus_Measure_Flag,(u8*)&Measure_Flag,1);	
			}
			
		}
	}	
	else if(uiPage == 20)
	{
		u16 uiTemp;

		read_dgus_vp(Dgus_Measure_Flag,(u8*)&Measure_Flag,1);	
		if(Measure_Flag == 2)
		{
			Measure_Flag = -1;
			write_dgus_vp(Dgus_Measure_Flag,(u8*)&Measure_Flag,1);	

			g_SysCfgParas.uiCurHumanAB ++;
			if(g_SysCfgParas.uiCurHumanAB > 1)
				g_SysCfgParas.uiCurHumanAB = 0;
			NorFlash_Write(Nor_Human_A_B,Dgus_Human_A_B,(u8*)&g_SysCfgParas.uiCurHumanAB,sizeof(g_SysCfgParas.uiCurHumanAB));
			LogPrint(0,"CurHuman(%d)",(u16)g_SysCfgParas.uiCurHumanAB);
			
		}
	}
	else if(uiPage == 28)
	{
		read_dgus_vp(Dgus_Rtc_Set,(u8*)&Rtc_Set[0],4);
		if(Rtc_Set[0] == 0x5AA5)
		{
			u8 rtcdata[8];
			u8 n,m;

			Rtc_Set[0] = 0;
			write_dgus_vp(Dgus_Rtc_Set,(u8*)&Rtc_Set[0],1);

			n=(Rtc_Set[1]>>8);
			m=Rtc_Set[1]&0xff;
			rtcdata[0]=(u8)(n/10)*16+(n%10);
			rtcdata[1]=(u8)(m/10)*16+(m%10);
		
			n=(Rtc_Set[2]>>8);
			m=Rtc_Set[2]&0xff;
			rtcdata[2]=(u8)(n/10)*16+(n%10);
			rtcdata[4]=(u8)(m/10)*16+(m%10);
			
			n=(Rtc_Set[3]>>8);
			m=Rtc_Set[3]&0xff;
			rtcdata[5]=(u8)(n/10)*16+(n%10);
			rtcdata[6]=(u8)(m/10)*16+(m%10);
			LogPrint(0,"SetTime:20%2X-%2X-%2X,%2X:%2X:%2X",(u16)rtcdata[0],(u16)rtcdata[1],(u16)rtcdata[2],(u16)rtcdata[4],(u16)rtcdata[5],(u16)rtcdata[6]);
			Rx8130_SetTime(rtcdata);
		}	
		read_dgus_vp(0x00A1,(u8*)&Temp_Data[0],1);
		if((Temp_Data[0]>>8) == 0)
			Sound_Lv = 1;
		else if((Temp_Data[0]>>8) == 0x20)
			Sound_Lv = 2;
		else if((Temp_Data[0]>>8) == 0x40)
			Sound_Lv = 3;
		else 
			Sound_Lv = 0;
			
		read_dgus_vp(0x0082,(u8*)&Temp_Data[0],1);
		if((Temp_Data[0]>>8) == 0x10)
			Light_Lv = 1;
		else if((Temp_Data[0]>>8) == 0x32)
			Light_Lv = 2;
		else if((Temp_Data[0]>>8) == 0x64)
			Light_Lv = 3;	
		else 
			Light_Lv = 0;	
		
		write_dgus_vp(Dgus_Sound_Lv,(u8*)&Sound_Lv,1);	
		write_dgus_vp(Dgus_Light_Lv,(u8*)&Light_Lv,1);
		if(Sound_Lv != Sound_Lv_Bak || Light_Lv != Light_Lv_Bak)
		{
			Sound_Lv_Bak = Sound_Lv;
			Light_Lv_Bak = Light_Lv;
			
		}
	
	}

	g_SysVar.uiLastPage = uiPage;		

}
/*******************************************************************************************
     : void DoSysStusPoll(void)
   : ϵͳ״̬־ڲѯʽ汾Թص
   : none
   : none
 ޸ʷ  :
        : 20211025
        : xujianping
 ޸   : 
********************************************************************************************/
void DoSysStusPoll(void)
{
	u16 uiTemp;
	u8 bRtcData[8];
	if((TimeElapsed(g_SysVar.ulLogOutLastTick,TICK_NOW)) > 1000)	//5붨ϵͳ״̬־ִһЩ״̬Ϣ
	{
		g_SysVar.ulLogOutLastTick = TICK_NOW;
		
		if(portChargStatus == 0)
			g_SysVar.uiChargeStatus = 1;
		else
			g_SysVar.uiChargeStatus = 0;
		
		read_dgus_vp(Dgus_PowerAd,(u8*)&g_SysVar.uiPowerAd,1);

		g_SysVar.uiPowerNow = g_SysVar.uiPowerAd*2*3300.0/4095;
		if(g_SysVar.uiPowerNow < 3300)
			g_SysVar.uiPowerLevel = 0;
		else if(g_SysVar.uiPowerNow < 3500)
			g_SysVar.uiPowerLevel = 1;
		else if(g_SysVar.uiPowerNow < 3700)
			g_SysVar.uiPowerLevel = 2;
		else if(g_SysVar.uiPowerNow < 3900)
			g_SysVar.uiPowerLevel = 3;
		else
			g_SysVar.uiPowerLevel = 4;
		write_dgus_vp(Dgus_Power_Level,(u8*)&g_SysVar.uiPowerLevel,1);
		write_dgus_vp(Dgus_Power_Now,(u8*)&g_SysVar.uiPowerNow,1);
		write_dgus_vp(Dgus_Charge_Flag,(u8*)&g_SysVar.uiChargeStatus,1);

		Rx8130_GetTime(bRtcData);		
	}
	
}

void DoDataProc(void)
{
	
}

/*******************************************************************************************
     : void High_Pressure_Report(u16 High_Pressure)
   : ѹ
   : High_Pressureѹֵ
   : none
 ޸ʷ  :
        : 2019625
        : liuyanzhou
 ޸   : 
        : xujianping
 ޸   : 
*********************************************************************************************/
void 	High_Pressure_Report(u16 High_Pressure)
{

	//High_Pressure = 128;
	Temp_Data[0] = 0x1601;
//	Temp_Data[1] = 0x4002;
	write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
	do{
		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
		delay_ms(100);
	}while(Temp_Data[1] & 0x000F);
	
	delay_ms(1000);

	
	//High_Pressure =123; 		
	Temp_Data[0] = High_Pressure/100;
	if(Temp_Data[0] > 0)
	{
		Temp_Data[0] = (Temp_Data[0]+ 90<<8 ) | 0x01;
		write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
		delay_ms(500);
		
	}
	
	Temp_Data[0] = High_Pressure%100/10;
	Temp_Data[1] = High_Pressure%10;
	if(Temp_Data[0] > 0)
	{		
		if(Temp_Data[0] == 1)
		{
			Temp_Data[0] = (Temp_Data[0] + 70 <<8) | 0x01;
			write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
			delay_ms(350);	
		}	
		Temp_Data[0] = (Temp_Data[0] + 80 <<8) | 0x01;
		write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
		delay_ms(500);
	}
	else
	{
		if(Temp_Data[1] > 0)
			Temp_Data[0] = (Temp_Data[0]+ 70 <<8 ) | 0x01;
			write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
			delay_ms(500);
	
	}	

	Temp_Data[0] = High_Pressure%10;
	if(Temp_Data[0] > 0)
	{	
		Temp_Data[0] = High_Pressure%10;
		Temp_Data[0] = (Temp_Data[0]+70<<8 ) | 0x01;
		write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
//		delay_ms(500);
	}
	do{
		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
		delay_ms(100);
	}while(Temp_Data[1] & 0x000F);
//	while(Temp_Data[1] & 0x000F)
//		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
	delay_ms(800);
}			
							
/*******************************************************************************************
     : void High_Pressure_Report(u16 Low_Pressure)
   : ѹ
   : Low_Pressureѹֵ
   : none
 ޸ʷ  :
        : 2019625
        : liuyanzhou
 ޸   : 
        : xujianping
 ޸   : 
********************************************************************************************/
void 	Low_Pressure_Report(u16 Low_Pressure)
{
	Temp_Data[0] = 0x1701;
	//Temp_Data[1] = 0x4002;
	write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
	do{
		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
		delay_ms(100);
	}while(Temp_Data[1] & 0x000F);
	delay_ms(1000);
//	while(Temp_Data[1] & 0x000F)
//		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 

	Temp_Data[0] = Low_Pressure/100;
	if(Temp_Data[0] > 0)
	{
		Temp_Data[0] = (Temp_Data[0]+ 90<<8 ) | 0x01;
		write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
		delay_ms(500);
		
	}
	
	Temp_Data[0] = Low_Pressure%100/10;
	Temp_Data[1] = Low_Pressure%10;
	if(Temp_Data[0] > 0)
	{		
		if(Temp_Data[0] == 1)
		{
			Temp_Data[0] = (Temp_Data[0] + 70 <<8) | 0x01;
			write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
			delay_ms(350);	
		}		
		Temp_Data[0] = (Temp_Data[0] + 80 <<8) | 0x01;
		write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
		delay_ms(500);
	}
	else
	{
		if(Temp_Data[1] > 0)
			Temp_Data[0] = (Temp_Data[0]+ 70 <<8 ) | 0x01;
			write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
			delay_ms(500);
	
	}	

	Temp_Data[0] = Low_Pressure%10;
	if(Temp_Data[0] > 0)
	{	
		Temp_Data[0] = Low_Pressure%10;
		Temp_Data[0] = (Temp_Data[0]+70<<8 ) | 0x01;
		write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
		delay_ms(500);
	}
	do{
		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
		delay_ms(100);
	}while(Temp_Data[1] & 0x000F);
	delay_ms(800);
//	while(Temp_Data[1] & 0x000F)
//		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
}			
	

/*******************************************************************************************
     : void MaiBo_Report(u16 MaiBo)
   : 
   : MaiBoֵ
   : none
 ޸ʷ  :
        : 2019625
        : liuyanzhou
 ޸   : 
        : xujianping
 ޸   : 
*********************************************************************************************/
void 	MaiBo_Report(u16 MaiBo)
{
	Temp_Data[0] = 0x1801;
	//Temp_Data[1] = 0x4002;
	write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
	do{
		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
		delay_ms(100);
	}while(Temp_Data[1] & 0x000F);
	delay_ms(1000);
//	while(Temp_Data[1] & 0x000F)
//		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 

	Temp_Data[0] = MaiBo/100;
	if(Temp_Data[0] > 0)
	{
		Temp_Data[0] = (Temp_Data[0]+ 90<<8 ) | 0x01;
		write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
		delay_ms(500);
		
	}
	
	Temp_Data[0] = MaiBo%100/10;
	Temp_Data[1] = MaiBo%10;
	if(Temp_Data[0] > 0)
	{		
		if(Temp_Data[0] == 1)
		{
			Temp_Data[0] = (Temp_Data[0] + 70 <<8) | 0x01;
			write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
			delay_ms(350);	
		}	
		Temp_Data[0] = (Temp_Data[0] + 80 <<8) | 0x01;
		write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
		delay_ms(500);
	}
	else
	{
		if(Temp_Data[1] > 0)
			Temp_Data[0] = (Temp_Data[0]+ 70 <<8 ) | 0x01;
			write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
			delay_ms(500);
	
	}	

	Temp_Data[0] = MaiBo%10;
	if(Temp_Data[0] > 0)
	{	
		Temp_Data[0] = MaiBo%10;
		Temp_Data[0] = (Temp_Data[0]+70<<8 ) | 0x01;
		write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
		delay_ms(500);
	}
	do{
		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
		delay_ms(100);
	}while(Temp_Data[1] & 0x000F);
	delay_ms(800);
//	while(Temp_Data[1] & 0x000F)
//		read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
}			
	

/*******************************************************************************************
     : void DoMeasureFsm(void)
   : Ѫѹ״̬
   : none
   : none
 ޸ʷ  :
        : 20211118
        : xujianping
 ޸   : 
********************************************************************************************/

void DoMeasureFsm(void)
{
		u16 uiTemp,i;	
		s8 bTemp;
		static u16 Count,Count1;
		u16 tempHead;
		s16 siTemp;
		s32 slTemp,slTemp2;

		switch(g_BpmCtx.enumFsm)
		{
			case BPM_IDLE:
				read_dgus_vp(Dgus_Measure_Flag,(u8*)&Measure_Flag,1);	
				if(Measure_Flag == 1)
				{
					Measure_Flag = -1;
					LogPrint(0,"BPMeasrueStart,don't move or speak please!",g_BpmCtx.siCurPressure);
					//ʾʼƶ˵
					Temp_Data[0] = 0x1401;
					write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
					delay_ms(50);
					while(Temp_Data[1] & 0x000F)
						read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
					write_dgus_vp(Dgus_Measure_Flag,(u8*)&Measure_Flag,1);	
					g_BpmCtx.ulSampLastTick = TICK_NOW;
					
					ShmReset(&g_qFilterA);
					ShmReset(&g_qFilterB);
					
					g_SysVar.slFilterABufSum = 0;
					g_SysVar.slFilterBBufSum = 0;
					
					g_BpmCtx.uiTimeout = 0;
					g_BpmCtx.uiSampCnt = 0;
					
					Start_Pump();	
					Stop_Valve();
					g_BpmCtx.enumFsm = BPM_SAMPLE;		
//					memset((u8*)g_BpmCtx.uiRawSampData,0,sizeof(g_BpmCtx.uiRawSampData));
					g_BpmCtx.uiTimeout = 0;
				}
				break;
			case BPM_SAMPLE:
				read_dgus_vp(Dgus_Measure_Flag,(u8*)&Measure_Flag,1);	
				if(Measure_Flag == 0)
				{
					Measure_Flag = -1;
					LogPrint(0,"Manual Stop Measure!");
					Stop_Pump();	
					Start_Valve();
					g_BpmCtx.enumFsm = BPM_IDLE;
					break;
				}
				
				if((TimeElapsed(g_BpmCtx.ulSampLastTick,TICK_NOW)) >= PRESS_SAMPLE_PERIOD)
				{
					g_BpmCtx.ulSampLastTick = TICK_NOW; 
					g_BpmCtx.uiTimeout ++;
					if(g_BpmCtx.uiTimeout > 60000/PRESS_SAMPLE_PERIOD)	//if not complete in 60 seconds,then timeout error 
					{
						LogPrint(0,"SampTimeout error!Return idle state!");
						Stop_Pump();	
						g_BpmCtx.enumFsm = BPM_IDLE;
					}
					bTemp = GetPressTemp(&slTemp,NULL);
					if(bTemp > 0)
					{
						/////////////////////////////////////////////////////////////
						//slider filter
						if(ShmLength(&g_qFilterA) == FILTERA_QSIZE)	
						{
							QDATA_TYPE qTempData;
							ShmOutBlock(&g_qFilterA, &qTempData, 1);
							g_SysVar.slFilterABufSum -= qTempData;
						}
						else
						{
							ShmInBlock(&g_qFilterA,&slTemp,1);
							g_SysVar.slFilterABufSum += slTemp;		
							break;		
						}

						ShmInBlock(&g_qFilterA,&slTemp,1);
						g_SysVar.slFilterABufSum += slTemp;		
						g_BpmCtx.slFiltedData = g_SysVar.slFilterABufSum/FILTERA_QSIZE;
						////////////////////////////////////////////////////////////////
						
						//=======================  Update of buffers and variables values  ========================//
						g_BpmCtx.slPreDerivative = g_BpmCtx.slFiltedData - g_BpmCtx.slPreFiltedData;
						g_BpmCtx.slPreFiltedData = g_BpmCtx.slFiltedData; 
						
						if (g_BpmCtx.slFiltedData >= 0x800000l) 
						{
							g_BpmCtx.siCurPressure = fK*(g_BpmCtx.slFiltedData - 0x1000000);	
						}
						else
						{
							g_BpmCtx.siCurPressure = fK*g_BpmCtx.slFiltedData;		
						}
						
						read_dgus_vp(0x310,(u8*)&Temp_Data[0],2);
						if(!Temp_Data[0])	
						{
							Temp_Data[0] = 0x5AA5;
							Temp_Data[1] = 0x0100; 
							Temp_Data[2] = 0x0001;
							Temp_Data[3] = g_BpmCtx.siCurPressure*100;
							write_dgus_vp(0x310,(u8*)&Temp_Data[0],4);	
						}

						g_BpmCtx.uiSampCnt ++;
						if(g_BpmCtx.uiSampCnt == 1000/PRESS_SAMPLE_PERIOD)
						{
							g_BpmCtx.uiSampCnt = 0;
							write_dgus_vp(Dgus_Pressure_Now_Display,(u8*)&g_BpmCtx.siCurPressure,1);	
						}

						if(g_BpmCtx.siCurPressure >= 180)
						{
								Stop_Pump();	
								g_BpmCtx.enumFsm = BPM_SAMPLE_WAIT1S;
								g_BpmCtx.ulSampLastTick = TICK_NOW;
						}
					}
//					WriteByte(0x01,0x01);	//for XGZP6829D
				}
				break;
			case BPM_SAMPLE_WAIT1S:
				if((TimeElapsed(g_BpmCtx.ulSampLastTick,TICK_NOW)) > 500)	//delay 0.5s for pressure stabilization
				{
					bTemp = GetPressTemp(&slTemp,NULL);
					if(bTemp > 0)
					{
						g_BpmCtx.slPreRawData = slTemp;
						////////////////////////////////////////////////////////////////
						if (slTemp >= 0x800000l) 
						{
							g_BpmCtx.siCurPressure = fK*(slTemp - 0x1000000);	//Ϊ0~40KPa
						}
						else
						{
							g_BpmCtx.siCurPressure = fK*slTemp;		//Ϊ0~40KPa
						}
					}
					g_BpmCtx.ulSampLastTick = TICK_NOW;
					g_BpmCtx.uiSampCnt = 0;
					g_BpmCtx.uiTimeout = 0;

					g_BpmCtx.uiPeakCnt = 0;
					g_BpmCtx.uiPeakTopCnt = 0;
					g_BpmCtx.uiPeakBottomCnt = 0;
					
					g_BpmCtx.enumFsm = BPM_SAMPLE_DATAPROC;
					LogPrint(0,"BPMeasrueStart...CurBP(%d)",g_BpmCtx.siCurPressure);
				}
				break;	
			case BPM_SAMPLE_DATAPROC:

				if((TimeElapsed(g_BpmCtx.ulSampLastTick,TICK_NOW)) >= PRESS_SAMPLE_PERIOD)
				{
					g_BpmCtx.ulSampLastTick = TICK_NOW; 
					g_BpmCtx.uiTimeout ++;
					if(g_BpmCtx.uiTimeout > 60000/PRESS_SAMPLE_PERIOD)	//if not complete in 60 seconds,then timeout error 
					{
						LogPrint(0,"SampOverProcTimeout(%d) error!Return idle state!",g_BpmCtx.uiTimeout);
						Start_Valve();	
						g_BpmCtx.enumFsm = BPM_IDLE;
						break;
					}
					bTemp = GetPressTemp(&slTemp,NULL);
					if(bTemp > 0)
					{
							if(labs(slTemp - g_BpmCtx.slPreRawData) > 10000)
							{
								slTemp = g_BpmCtx.slPreRawData;
							}
							g_BpmCtx.slPreRawData = slTemp;
							/////////////////////////////////////////////////////////////
							if(ShmLength(&g_qFilterB) == FILTERB_QSIZE)	
							{
								QDATA_TYPE qTempData;
								g_BpmCtx.slPreFiltedData = g_SysVar.slFilterBBufSum/FILTERB_QSIZE;
								ShmOutBlock(&g_qFilterB, &qTempData, 1);
								g_SysVar.slFilterBBufSum -= qTempData;

								ShmInBlock(&g_qFilterB,&slTemp,1);
								g_SysVar.slFilterBBufSum += slTemp;		
								g_BpmCtx.slFiltedData = g_SysVar.slFilterBBufSum/FILTERB_QSIZE;
							}
							else
							{
								ShmInBlock(&g_qFilterB,&slTemp,1);
								g_SysVar.slFilterBBufSum += slTemp;		
							}
							
							////////////////////////////////////////////////////////////////
							if (g_BpmCtx.slFiltedData >= 0x800000l) 
							{
								g_BpmCtx.siCurPressure = fK*(g_BpmCtx.slFiltedData - 0x1000000);	//Ϊ0~40KPa
							}
							else
							{
								g_BpmCtx.siCurPressure = fK*g_BpmCtx.slFiltedData;		
							}

							Temp_Data[0] = 0x5AA5;
							Temp_Data[1] = 0x0100; 
							Temp_Data[2] = 0x0001;
							Temp_Data[3] = g_BpmCtx.siCurPressure*100;
							write_dgus_vp(0x310,(u8*)&Temp_Data[0],4);	

							g_BpmCtx.uiSampCnt ++;
							if(g_BpmCtx.uiSampCnt == 1000/PRESS_SAMPLE_PERIOD)
							{
								g_BpmCtx.uiSampCnt = 0;
								write_dgus_vp(Dgus_Pressure_Now_Display,(u8*)&g_BpmCtx.siCurPressure,1);	
							}


							//=======  New derivative value calculation  =======//			
							g_BpmCtx.slDerivative = g_BpmCtx.slFiltedData - g_BpmCtx.slPreFiltedData;

							if( ( g_BpmCtx.slDerivative * g_BpmCtx.slPreDerivative) <= 0 ) 
							{ 
								if((g_BpmCtx.slDerivative - g_BpmCtx.slPreDerivative) < 0)	//summit
								{
									if( g_BpmCtx.uiPeakCnt == 3 )
									{
										g_BpmCtx.uiSBP = g_BpmCtx.siCurPressure ;
									}	 									
									if(g_BpmCtx.ulPeakBottomAD[g_BpmCtx.uiPeakCnt - PEAKSTART] && !g_BpmCtx.ulPeakTopAD[g_BpmCtx.uiPeakCnt - PEAKSTART])
									{
										if( g_BpmCtx.uiPeakCnt == PEAKSTART )	 									
										{ 
											g_BpmCtx.ulLastPeakTopTick = TICK_NOW;
											g_BpmCtx.ulPeakTopAD[0] = g_BpmCtx.slFiltedData; 
											g_BpmCtx.uiDiffValue[g_BpmCtx.uiPeakCnt - PEAKSTART] = g_BpmCtx.ulPeakTopAD[g_BpmCtx.uiPeakCnt - PEAKSTART] - g_BpmCtx.ulPeakBottomAD[g_BpmCtx.uiPeakCnt - PEAKSTART];
											g_BpmCtx.uiPeakTopBP[g_BpmCtx.uiPeakCnt - PEAKSTART] = g_BpmCtx.siCurPressure;
										}
										else if(( g_BpmCtx.uiPeakCnt >= PEAKSTART ) && ( g_BpmCtx.uiPeakCnt < PEAKSTOP ))
										{
											if((TimeElapsed(g_BpmCtx.ulLastPeakTopTick,TICK_NOW)) < 250)
											{
												if(g_BpmCtx.slFiltedData > g_BpmCtx.ulPeakTopAD[g_BpmCtx.uiPeakCnt-1])
												{
													g_BpmCtx.ulPeakTopAD[g_BpmCtx.uiPeakCnt-1] = g_BpmCtx.slFiltedData;
													g_BpmCtx.uiDiffValue[g_BpmCtx.uiPeakCnt - PEAKSTART] = g_BpmCtx.ulPeakTopAD[g_BpmCtx.uiPeakCnt - PEAKSTART] - g_BpmCtx.ulPeakBottomAD[g_BpmCtx.uiPeakCnt - PEAKSTART];
													g_BpmCtx.uiPeakTopBP[g_BpmCtx.uiPeakCnt - PEAKSTART] = g_BpmCtx.siCurPressure;
												}
											}
											else
											{
												g_BpmCtx.ulLastPeakTopTick = TICK_NOW;
												g_BpmCtx.ulPeakTopAD[g_BpmCtx.uiPeakCnt - PEAKSTART] = g_BpmCtx.slFiltedData; 
												g_BpmCtx.uiDiffValue[g_BpmCtx.uiPeakCnt - PEAKSTART] = g_BpmCtx.ulPeakTopAD[g_BpmCtx.uiPeakCnt - PEAKSTART] - g_BpmCtx.ulPeakBottomAD[g_BpmCtx.uiPeakCnt - PEAKSTART];
												g_BpmCtx.uiPeakTopBP[g_BpmCtx.uiPeakCnt - PEAKSTART] = g_BpmCtx.siCurPressure;
											}
										}
									}
									
								}
								else //if((g_BpmCtx.slDerivative - g_BpmCtx.slPreDerivative) > 0) //vally
								{
									g_BpmCtx.uiPeakCnt ++;
									if( g_BpmCtx.uiPeakCnt == PEAKSTART )	 									
									{ 
											g_BpmCtx.ulPeakBottomAD[0] = g_BpmCtx.slFiltedData; 
											g_BpmCtx.ulLastPeakBottomTick = TICK_NOW;
											g_BpmCtx.ulPulsarStartTick = TICK_NOW;
										
									}
									else if(( g_BpmCtx.uiPeakCnt > PEAKSTART ) && ( g_BpmCtx.uiPeakCnt < PEAKSTOP ))
									{
										if((TimeElapsed(g_BpmCtx.ulLastPeakBottomTick,TICK_NOW)) < 250)
										{
//											if(g_BpmCtx.slFiltedData < g_BpmCtx.ulPeakBottomAD[g_BpmCtx.uiPeakCnt-1])
											{
//												g_BpmCtx.ulPeakBottomAD[g_BpmCtx.uiPeakCnt-1] = g_BpmCtx.slFiltedData;
												g_BpmCtx.uiPeakCnt --;
											}
										}
										else
										{
											g_BpmCtx.ulPeakBottomAD[g_BpmCtx.uiPeakCnt - PEAKSTART] = g_BpmCtx.slFiltedData; 
											g_BpmCtx.ulLastPeakBottomTick = TICK_NOW;
										}
									}
									else if(g_BpmCtx.uiPeakCnt == PEAKSTOP)
									{
										u32 temp = TimeElapsed(g_BpmCtx.ulPulsarStartTick,TICK_NOW);
										g_BpmCtx.uiPulsar = (u32)(PEAKSTOP-PEAKSTART)*60000ul / temp;
									}
								}
							}
						
							//============  Variables update  =============//
							g_BpmCtx.slPreDerivative = g_BpmCtx.slDerivative;
								
							//============  Ending calculations  ==============//
							if( g_BpmCtx.siCurPressure < 50 ) 
							{ 
								float fMax = 0.0;
								u16 bMAPIdx;
								u8	bRtcData[8];
								u16 uiNor_HistoryCurve_AddrBase,uiNor_HistoryDate_AddrBase,uiNor_HistoryTime_AddrBase;
								
								Start_Valve();

								if(g_SysCfgParas.uiCurHumanAB)
								{
									uiNor_HistoryCurve_AddrBase = Nor_HistoryCurveB_AddrBase;
									uiNor_HistoryDate_AddrBase = Nor_HistoryDateB_AddrBase;
									uiNor_HistoryTime_AddrBase = Nor_HistoryTimeB_AddrBase;
								}
								else
								{
									uiNor_HistoryCurve_AddrBase = Nor_HistoryCurveA_AddrBase;
									uiNor_HistoryDate_AddrBase = Nor_HistoryDateA_AddrBase;
									uiNor_HistoryTime_AddrBase = Nor_HistoryTimeA_AddrBase;
								}
								
								for(i=0; i<(PEAKSTOP-PEAKSTART); i++)
								{
									if(g_BpmCtx.uiDiffValue[i] > (u16)fMax)
									{
										fMax = g_BpmCtx.uiDiffValue[i];
										bMAPIdx = i;
										g_BpmCtx.uiMAP = g_BpmCtx.uiPeakTopBP[i];
									}
								}
								LogPrint(0,"Find MAP:%d-MAPIDX:%d",g_BpmCtx.uiMAP,bMAPIdx);

								uiTemp = fMax*0.3;
								LogPrint(0,"Find SBP1:%d",g_BpmCtx.uiSBP);
								for(i=0; i<bMAPIdx; i++)
								{
									if(i+1 < bMAPIdx)
									if(g_BpmCtx.uiDiffValue[i+1] >= uiTemp && g_BpmCtx.uiDiffValue[i] <= uiTemp)
									{
										g_BpmCtx.uiSBP = g_BpmCtx.uiPeakTopBP[i];
										LogPrint(0,"Find SBP2:%d",g_BpmCtx.uiSBP);
										break;
									}										
								}
								g_BpmCtx.uiDBP = (g_BpmCtx.uiMAP*3 - g_BpmCtx.uiSBP) / 2;
								LogPrint(0,"Find DBP1:%d",g_BpmCtx.uiDBP);

								uiTemp = fMax*0.7;
								for(i=bMAPIdx+1; i<PEAKSTOP; i++)
								{
									if(i+1 < PEAKSTOP)
									if(g_BpmCtx.uiDiffValue[i] >= uiTemp && g_BpmCtx.uiDiffValue[i+1] <= uiTemp)
									{
										g_BpmCtx.uiDBP = g_BpmCtx.uiPeakTopBP[i+1];
										LogPrint(0,"Find DBP2:%d",g_BpmCtx.uiDBP);
										break;
									}										
								}
								LogPrint(0,"SBP:%d-DBP:%d-PUL:%d",g_BpmCtx.uiSBP,g_BpmCtx.uiDBP,g_BpmCtx.uiPulsar);
								
								g_SysVar.siHistoryDataPtr = g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]%HISTORY_CURVE_POINT_MAX_NUM;
								LogPrint(0,"Current HistoryCurve Ptr(%X)",g_SysVar.siHistoryDataPtr);
								
								slTemp = (u32)g_BpmCtx.uiSBP << 16 | (u32)g_BpmCtx.uiDBP << 8 | g_BpmCtx.uiPulsar;
								NorFlash_Write(uiNor_HistoryCurve_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
								uiTemp = uiNor_HistoryCurve_AddrBase + (g_SysVar.siHistoryDataPtr<<1);
								LogPrint(0,"WriteNor%X(ptr%d):SBP(%d)-DBP(%d)-PUL(%d)",uiTemp,g_SysVar.siHistoryDataPtr,(u16)(slTemp>>16),(u16)((slTemp>>8)&0xff),(u16)(slTemp&0xff));

								#if 0
								//Test
								slTemp = 0;
								NorFlash_Read(uiNor_HistoryCurve_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Temp_vp,(u8*)&slTemp,4);
								
								LogPrint(0,"ReadNor%X(ptr%d):SBP(%d)-DBP(%d)-PUL(%d)",uiTemp,g_SysVar.siHistoryDataPtr,(u16)(slTemp>>16),(u16)((slTemp>>8)&0xff),(u16)(slTemp&0xff));
								#endif

								
								Rx8130_GetTime(bRtcData);
//								LogPrint(0,"ReadRtc:%d-%d-%d %d:%d:%d",(u16)bRtcData[0],(u16)bRtcData[1],(u16)bRtcData[2],(u16)bRtcData[4],(u16)bRtcData[5],(u16)bRtcData[6]);
								slTemp = (u32)bRtcData[0]<<16 | (u32)bRtcData[1]<<8 | bRtcData[2];
								NorFlash_Write(uiNor_HistoryDate_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Temp_vp,(u8*)&slTemp,sizeof(slTemp));
								uiTemp = uiNor_HistoryDate_AddrBase + g_SysVar.siHistoryDataPtr<<1;
								LogPrint(0,"WriteNorDate%X(ptr%d):%d-%d-%d",uiTemp,g_SysVar.siHistoryDataPtr,(u16)bRtcData[0],(u16)bRtcData[1],(u16)bRtcData[2]);

								slTemp = (u32)bRtcData[4]<<16 | (u32)bRtcData[5]<<8 | bRtcData[6];
								NorFlash_Write(uiNor_HistoryTime_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Temp_vp,(u8*)&slTemp,sizeof(slTemp));
								uiTemp = uiNor_HistoryTime_AddrBase + g_SysVar.siHistoryDataPtr<<1;
								LogPrint(0,"WriteNorTime%X(ptr%d):%d:%d:%d",uiTemp,g_SysVar.siHistoryDataPtr,(u16)bRtcData[4],(u16)bRtcData[5],(u16)bRtcData[6]);

								#if 0
								//Test
								NorFlash_Read(uiNor_HistoryDate_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Test_Vp,(u8*)&Temp_Data[0],4);
								NorFlash_Read(uiNor_HistoryTime_AddrBase + g_SysVar.siHistoryDataPtr<<1,Dgus_Test_Vp,(u8*)&Temp_Data[2],4);
								LogPrint(0,"ReadNor(ptr%d):%d-%d-%d %d:%d:%d",g_SysVar.siHistoryDataPtr,Temp_Data[0]&0xff,Temp_Data[1]>>8,Temp_Data[1]&0xff,Temp_Data[2]&0xff,Temp_Data[3]>>8,Temp_Data[3]&0xff);
								#endif

								g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]++;

								NorFlash_Write(Nor_HistoryADataCnt+g_SysCfgParas.uiCurHumanAB<<1,Dgus_Temp_vp,(u8*)&g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB],sizeof(g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]));
								LogPrint(0,"Save HistoryCurve Cnt(%ld)",g_SysCfgParas.ulHistoryDataCnt[g_SysCfgParas.uiCurHumanAB]);
								
								Page_Change(25);
								
								write_dgus_vp(Dgus_High_Pressure,(u8*)&g_BpmCtx.uiSBP,1);
								write_dgus_vp(Dgus_Low_Pressure,(u8*)&g_BpmCtx.uiDBP,1);
								write_dgus_vp(Dgus_MaiBo,(u8*)&g_BpmCtx.uiPulsar,1);
								
								if(g_BpmCtx.uiSBP>=90 && g_BpmCtx.uiSBP<=140)
									uiTemp = 0;
								else if(g_BpmCtx.uiSBP<90)
									uiTemp = 2;
								else
									uiTemp = 1;
								write_dgus_vp(Dgus_High_Pressure_Flag,(u8*)&uiTemp,1);
								LogPrint(0,"Dgus_High_Pressure_Flag(%d)",uiTemp);
								
								if(g_BpmCtx.uiDBP>=60 && g_BpmCtx.uiDBP<=90)
									uiTemp = 0;
								else if(g_BpmCtx.uiDBP<60)
									uiTemp = 2;
								else
									uiTemp = 1;
								write_dgus_vp(Dgus_Low_Pressure_Flag,(u8*)&uiTemp,1);
								LogPrint(0,"Dgus_Low_Pressure_Flag(%d)",uiTemp);
								
								if(g_BpmCtx.uiPulsar>=60 && g_BpmCtx.uiPulsar<=100)
									uiTemp = 0;
								else if(g_BpmCtx.uiPulsar<60)
									uiTemp = 2;
								else
									uiTemp = 1;
								write_dgus_vp(Dgus_MaiBo_Flag,(u8*)&uiTemp,1);
								LogPrint(0,"Dgus_MaiBo_Flag(%d)",uiTemp);
								
								Temp_Data[0] = 0x1501;
								write_dgus_vp(0x00A0,(u8*)Temp_Data,1); 
								do{
									read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
									delay_ms(100);
								}while(Temp_Data[1] & 0x000F);
//								while(Temp_Data[1] & 0x000F)
//									read_dgus_vp(0x00A1,(u8*)&Temp_Data[1],1); 
								delay_ms(800);
								//ѹ
								High_Pressure_Report(g_BpmCtx.uiSBP);
								//ѹ
								Low_Pressure_Report(g_BpmCtx.uiDBP);
								//
								MaiBo_Report(g_BpmCtx.uiPulsar);
								g_BpmCtx.enumFsm = BPM_IDLE;
							}
					}
				}
				break;
			default:
				break;
		}
}

/*******************************************************************************************
     : void main(void)
   : 
   : none
   : none
 ޸ʷ  :
        : 20211025
        : xujianping
 ޸   : 
********************************************************************************************/
void main(void)
{
	//====== Initialization of pointers ======//
	u8 bTemp,i;
	u32 ulTemp;
	g_bitFlag.all = 0;
	memset((u8*)&g_SysVar,0,sizeof(g_SysVar));
	g_SysVar.uiLastPage = -1;
	
//	delay_ms(100);

	T2_Init();								
	Rx8130_Init();
	Mpr_Init();
	Relay_Init();
	
	UartInit(UART5,115200);		
	

  ShmInit(&g_qFilterA, FILTERA_QSIZE+1,  g_nFilterABuff);		
  ShmInit(&g_qFilterB, FILTERB_QSIZE+1,  g_nFilterBBuff);		
	
	g_SysVar.ulLogOutLastTick = TICK_NOW;			
	g_SysVar.ulReportLastTick = TICK_NOW;			
	g_SysVar.ulPressSampLastTick = TICK_NOW;	
	
	//
	g_BpmCtx.enumFsm = BPM_IDLE;
	g_BpmCtx.ulSampLastTick = TICK_NOW;

	#if (USE_YSPMA40D == 0)
	
	WriteByte(0x01,0x01);	

	ReadByte(0x02,&bTemp);	
	bTemp &= ~0x1c;
	WriteByte(0x02,(u8)bTemp);	
	
	//TEST ONLY
	#if 0
	ReadByte(0x00,&bTemp);	
	LogPrint(0,"Reg00(%2X)",(u16)bTemp);

	ReadByte(0x01,&bTemp);	
	LogPrint(0,"Reg01(%2X)",(u16)bTemp);

	ReadByte(0x02,&bTemp);	
	LogPrint(0,"Reg02(%2X)",(u16)bTemp);
	#endif
	
	#endif
	EA = 1;
	
	LogPrint(0,"MainProg Start...");
	
	PeriTest();
	
	InitCurveChannel(1,0);
	InitCurveChannel(2,0);
	InitCurveChannel(3,0);
	LoadParas(0);

	while(1)
	{
		DoMeasureFsm();
		DoSysStusPoll();
		UiPagePoll();
	}
}



