#ifndef _MAIN_H_
#define _MAIN_H_

#define USE_RAW_IS_AD 	1
#define USE_IIR_FILTER  0

#define PRESS_SAMPLE_PERIOD			20						//ѹ
#define PRESS_SAMPVAL_QSIZE 		(60000/PRESS_SAMPLE_PERIOD) //Ϊһӵݼ¼,λΪ24λADֵ

#define RELAY_PUMP			1
#define RELAY_VALVE			2

#define Line_Point_Count 380
#define Sample_Max_Count 2200
#define	Human_A 0
#define Human_B 1
#define	KS 50
#define KD 70

#define PEAKSTART 3	//ӵN忪ʼ
#define PEAKSTOP  33	//ӵN忪ʼ

typedef enum{
	BPM_NULL = 0,
	BPM_IDLE,
	BPM_SAMPLE,
	BPM_SAMPLE_WAIT1S,
	BPM_SAMPLE_DATAPROC
}BpmFsmDef;

typedef struct{
	BpmFsmDef enumFsm;
	u32	ulSampLastTick;
	u16 uiSampCnt;
	u32 ulPeakTopAD[PEAKSTOP - PEAKSTART];
	u16 uiPeakTopBP[PEAKSTOP - PEAKSTART];
	u32 ulPeakBottomAD[PEAKSTOP - PEAKSTART];
	u16 uiDiffValue[PEAKSTOP - PEAKSTART];
	u16 uiSBP;
	u16 uiDBP;
	u16 uiMAP;
	u16 uiPulsar;
	u16 uiTimeout;
	s16 siCurPressure;
	s32 slRawData;
	s32 slPreRawData;
	s32 slPreFiltedData;
	s32 slFiltedData;
	s32 slPreDerivative;
	s32 slDerivative;
	u32	ulLastPeakBottomTick;
	u32	ulLastPeakTopTick;
	u16 uiPeakCnt;
	u16 uiPeakBottomCnt;
	u16 uiPeakTopCnt;
	u32 ulPulsarStartTick;
}BpmCtxDef;

typedef union 
{
	struct{
		u16 bPumpOnOff				:1;	//cooling compressor on/off(0:off,1:on)
		u16 bValveOnOff				:1;	//freezing compressor on/off(0:off,1:on)
		u16 bSensorFault			:1;	//Press sensor fault(0:normal,1:fault)
		u16 bReserved					:13;
	}bits;
	u16 all;
}SysFlagDef;

//#pragma pack(4)
typedef struct 
{
	u32 ulLogOutLastTick;
	u32 ulReportLastTick;
	u32 ulPressSampLastTick;
	s32 slFilterABufSum;
	s32 slFilterBBufSum;
	s32 slFilteredData;
	s16 siHistoryDataPtr;	
	s16 siArrowPos;	
	u16 uiPowerAd;
	u16 uiPowerNow;
	u16 uiChargeStatus;
	u16 uiPowerLevel;
	u16 uiLastPage;
}SysVarDef;
//#pragma pack ()

extern SysFlagDef 	g_bitFlag;
extern SysVarDef 		g_SysVar;
extern BpmCtxDef 		g_BpmCtx;
void	Init_Flash();
void InitCurveChannel(u8 bChannel,u8 bEnable);
void DrawPoint(u16 uiData,u8 uiChannel);
#endif
