#ifndef __MODBUS_H
#define __MODBUS_H

#include "sys.h"


/* Modbus function codes */
#define MODBUS_FC_READ_COILS                0x01
#define MODBUS_FC_READ_DISCRETE_INPUTS      0x02
#define MODBUS_FC_READ_HOLDING_REGISTERS    0x03
#define MODBUS_FC_READ_INPUT_REGISTERS      0x04
#define MODBUS_FC_WRITE_SINGLE_COIL         0x05
#define MODBUS_FC_WRITE_SINGLE_REGISTER     0x06
#define MODBUS_FC_READ_EXCEPTION_STATUS     0x07
#define MODBUS_FC_WRITE_MULTIPLE_COILS      0x0F
#define MODBUS_FC_WRITE_MULTIPLE_REGISTERS  0x10
#define MODBUS_FC_REPORT_SLAVE_ID           0x11
#define MODBUS_FC_MASK_WRITE_REGISTER       0x16
#define MODBUS_FC_WRITE_AND_READ_REGISTERS  0x17


#define MODBUS_MODE							0x2300							
#define MODBUS_SALVE_SET_ADDR				0x2301

#define MODBUS_SALVE						0x5AAA


#define MODBUS_BUFFER_LEN	256
extern u8	Modbus_Buffer[MODBUS_BUFFER_LEN];
extern u16 modbus_rx_status;
extern u16 Modbus_Salve_Addr_Val;
extern u16	Modbus_Mode;
extern u8	Modbus_Salve_Addr;




u16 crc16_modbus(u8 *dat, u16 length);
void Modbus_Init(void);
void Modbus_Salve_Handler(void);









#endif

